#pragma once

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Diagnostics;
using namespace Extensibility;
using namespace System::Windows::Forms;
using namespace System::Runtime::InteropServices;
 
namespace AdxHT_003_VC
{
    //Add-in Express Add-in Module
    [GuidAttribute("F78C6731-969C-46F0-AA42-8FD009B3C5FA"), ProgId("AdxHT_003_VC.AddinModule")]
    __gc public class AddinModule : public AddinExpress::MSO::ADXAddinModule
    {
	private: 
		System::String* LastEntryID;
    	Outlook::_Application* OutlookHost();

	public:

        AddinModule(void): AddinExpress::MSO::ADXAddinModule()
        {
            InitializeComponent();
        }
        AddinModule(System::ComponentModel::IContainer *container) : components(0)
        {
            /// <summary>
            /// Required for Windows.Forms Class Composition Designer support
            /// </summary>
 
            container->Add(this);
            InitializeComponent();
        }
 
        System::ComponentModel::IContainer* GetContainer()
        {
            return components;
        }
 
        void UninstallControls()
        {
            AddinExpress::MSO::ADXAddinModule::UninstallControls();
        }
 
        [ComRegisterFunctionAttribute]
        static void AddinRegister(System::Type* t)
        {
            AddinExpress::MSO::ADXAddinModule::ADXRegister(t);
        }
 
        [ComUnregisterFunctionAttribute]
        static void AddinUnregister(System::Type* t)
        {
            AddinExpress::MSO::ADXAddinModule::ADXUnregister(t);
        }
 
    protected:
        void Dispose(Boolean disposing)
        {
            if (disposing && components)
            {
                components->Dispose();
            }
            __super::Dispose(disposing);
        }
	private: AddinExpress::MSO::ADXOutlookAppEvents *  adxOutlookEvents;
	private: System::ComponentModel::IContainer *  components;

    private:
        /// <summary>
        /// Required designer variable.
        /// </summary>

 
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        void InitializeComponent(void)
        {
			this->components = new System::ComponentModel::Container();
			this->adxOutlookEvents = new AddinExpress::MSO::ADXOutlookAppEvents(this->components);
			// 
			// adxOutlookEvents
			// 
			this->adxOutlookEvents->ExplorerFolderSwitch += new AddinExpress::MSO::ADXOlExplorer_EventHandler(this, adxOutlookEvents_ExplorerFolderSwitch);
			this->adxOutlookEvents->ExplorerSelectionChange += new AddinExpress::MSO::ADXOlExplorer_EventHandler(this, adxOutlookEvents_ExplorerSelectionChange);
			// 
			// AddinModule
			// 
			this->AddinName = S"OlExample3 (VC)";
			this->SupportedApps = AddinExpress::MSO::ADXOfficeHostApp::ohaOutlook;
			this->AddinStartupComplete += new AddinExpress::MSO::ADXEvents_EventHandler(this, AddinModule_AddinStartupComplete);
			this->AddinInitialize += new AddinExpress::MSO::ADXEvents_EventHandler(this, AddinModule_AddinInitialize);
			this->AddinBeginShutdown += new AddinExpress::MSO::ADXEvents_EventHandler(this, AddinModule_AddinBeginShutdown);

		}
	public:
		void DoSelectionChange(void);
		void DoMyActionOnSelectionChange(System::Object* item);
	private: 
		System::Void AddinModule_AddinInitialize(System::Object *  sender, System::EventArgs *  e)
		{
		}

	
	private: 
		System::Void AddinModule_AddinStartupComplete(System::Object *  sender, System::EventArgs *  e)
		{
            DoStartupComplete(sender, e);
		}
        System::Void DoStartupComplete(System::Object *  sender, System::EventArgs *  e);

	private: 
		System::Void AddinModule_AddinBeginShutdown(System::Object *  sender, System::EventArgs *  e)
		{
		   DoBeginShutdown(sender, e);
		}
        System::Void DoBeginShutdown(System::Object *  sender, System::EventArgs *  e);


	private: System::Void adxOutlookEvents_ExplorerSelectionChange(System::Object *  sender, System::Object *  explorer)
		 {
			 DoSelectionChange();
		 }

	private: System::Void adxOutlookEvents_ExplorerFolderSwitch(System::Object *  sender, System::Object *  explorer)
		 {
			 DoSelectionChange();
		 }

	};
}

